unit LOGI_Roby1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, OleCtrls, SPIRIT, Menus,RCXdata,Reset_Roby1,LogiHelp, ExtCtrls,Grid,Slots;

type
  TFormLogi = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Spirit1: TSpirit;
    ListBox1: TListBox;   {only used for tests}
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    Install1: TMenuItem;
    Panel1: TPanel;
    Image1: TImage;
    Button2: TButton;
    Testgitter1: TMenuItem;
    Image2: TImage;
    Installieren1: TMenuItem;
    Hilfe1: TMenuItem;
    Hauptprogramm1: TMenuItem;
    Zoomout: TMenuItem;
    Zoomin1: TMenuItem;
    Hauptprogramm2: TMenuItem;
    Parameter1: TMenuItem;
    Slot1: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure Spirit1DownloadDone(Sender: TObject; ErrorCode,
      DownloadNo: Smallint);
    procedure Memo1Change(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Send1Click(Sender: TObject);
    procedure Parameters1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Help1Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Testgitter1Click(Sender: TObject);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button2Click(Sender: TObject);
    procedure ZoomoutClick(Sender: TObject);
    procedure Zoomin1Click(Sender: TObject);
    procedure Hauptprogramm2Click(Sender: TObject);
    procedure Slot1Click(Sender: TObject);
  private
    { Private declarations }
    procedure error(error_code:integer);
    function AnalyseCommand(buffer:string):boolean;
    procedure doTheAnalyse;
    function testports:boolean;
    function testpadpos(argument:real):integer;
    procedure clear_image;
    procedure draw_turtle;
    procedure draw_lines;
    procedure Execute_code(start,finish:integer);
  public
    { Public declarations }
  end;

var
  FormLogi: TFormLogi;

implementation

{$R *.DFM}
type TActualText=(Command_,Param_);
type TCC=array[0..1]of string[10];
const n:integer=28;
      LOGI_Instruction:array[1..28] of string[10]=('FORWARD','LEFT','RIGHT','REPEAT',
   'MISSION','DIRECTION',']','ALPHA','BETA','GAMMA','DELTA','EPSILON','N','W','E','S','NW',
   'NE','SW','SE','NNW','NWW','SSW','SWW','NNE','NEE','SSE','SEE');

const Lego_rotation_type=4;   // sensors

      Left_motor='2';    // motors
      Right_motor='0';
      drive_motors='02';
      mission_motor='1';

const forward_=0;        // subroutines
      left_=1;
      right_=2;
      mission_=3;
      cap_=4;

const procedure_=1;        // tasks

const argument=0;        // variables
      time_per_dm=2;
      time_per_90=3;
      rotations_per_dm=4;
      rotations_per_90=5;

      rotations=6;
      direction=7;
      calc=8;



var commandcode,buffer,buff:string;
    compiledCodeCount,MainIndex,StartCommandIndex,
    StartSelectionIndex,endCommandIndex,grid_step,grid_width,start_x,start_y,
    repeat_level_counter,Zoom:integer;
    alpha,posx,posy:real;
    compiledCode:array[1..2000]of TCC;
    ActualText:TActualText;
    WaitForCommand,WaitForParam,alreadyError,first,dirty,Star:boolean;

    
procedure TFormLogi.Button1Click(Sender: TObject);

var open_,close_,idx0,idx1:integer;
    ActualChar:char;
     comment_flag:boolean;
label 1;
begin
  repeat_level_counter:=0;
  alreadyerror:=false;
  listbox1.clear;
   star:=false;
  if not memo1.focused then memo1.setfocus;
  compiledCodeCount:=0;
  WaitForCommand:=true;  {flag that indicates whether LOGI expects a command}
  WaitForParam:=false;  {flag that indicates whether LOGI expects a command}
  ActualText:=Command_;
  first:=true;  {the first blanks before the first command don't count}
  if memo1.lines.count>2000 then begin error(12);exit;end; {too many lines}
  if memo1.lines.count<1 then begin error(0);exit;end else  {if memo empty}
     begin

       open_:=0;close_:=0; {counters for opened and closed brakets}
       buffer:='';         {resets the buffer}
       mainindex:=-2;  {needed for error treatment}
       for idx0:=0 to memo1.lines.count-1 do     {scan the memo}
           begin
             comment_flag:=false;
             if alreadyerror then exit;
             mainindex:=mainindex+2;{counts the memo1.text property with linefeed}
             dotheAnalyse;
             for idx1:=1 to length(memo1.lines[idx0]) do {scan the actual line}
                begin
                  
                  mainindex:=mainindex+1;   {next character}
                  actualchar:=memo1.lines[idx0][idx1];
               {------------------------------------------------------}
                 if actualchar='/' then comment_flag:=true;
                 if comment_flag then goto 1; {hue!! goto igitt!}
                   if actualchar='*' then star:=true;
                   if actualchar='[' then  open_:=open_+1 else


                   if (actualchar<>' ')and(actualchar<>'*') then
                     begin
                      if WaitForCommand then
                        begin
                         StartCommandIndex:=MainIndex; {to know where we are}
                         StartSelectionIndex:=MainIndex; {for selection use}
                         WaitForCommand:=false;
                         first:=false;
                        end;

                      if WaitForParam then
                        begin
                         StartSelectionIndex:=MainIndex;
                         waitForParam:=false;
                         first:=false;
                        end;


                      if actualchar=']' then  close_:=close_+1;
                       if close_>open_ then begin error(13);exit;end;

                      buffer:=buffer+actualchar;

                    end else dotheanalyse;
                  1: {if comment}
                end;
           end;
       if open_<>close_ then begin error(7);exit;end;
       if not star then begin error(8);exit;end;
     end;
  if not alreadyerror then draw_lines;
end;
  {-------------------------------------------------------}
procedure TFormLogi.Button2Click(Sender:TObject);
var idx0:integer;
begin
button1click(sender);
if not alreadyerror then
if testports then
  with spirit1 do
  begin

    selectprgm(formslot.radiogroup1.itemindex);
    beginoftask(1);
    setvar(direction,con,0); //equivalent to alpha, has to be reset

    if compiledCodeCount>0 then
    for idx0:=1 to compiledCodeCount do
     begin
       if compiledCode[idx0][0]='F' then
          begin setvar(0,2,strToint(compiledCode[idx0][1]));gosub(forward_); end;
       if compiledCode[idx0][0]='L' then
          begin
           setvar(argument,2,strToint(compiledCode[idx0][1]));
           gosub(Left_);
          end;
       if compiledCode[idx0][0]='R' then
          begin
           setvar(argument,2,strToint(compiledCode[idx0][1]));
           gosub(Right_);
          end;
       if compiledCode[idx0][0][1]='D' then
          begin loop(2,strToint(compiledCode[idx0][1])); end;
       if compiledCode[idx0][0]='P' then
          begin setvar(0,2,strToint(compiledCode[idx0][1]));gosub(Mission_); end;
       if compiledCode[idx0][0]='K' then
          begin
           setvar(argument,2,strToint(compiledCode[idx0][1]));
           gosub(Cap_);
          end;
       if compiledCode[idx0][0][1]=']' then endloop;
      end;

    EndOfTask();

  end else messagedlg('Communicationproblem',mterror,[mbOK],0);
end;

procedure TFormLogi.doTheAnalyse;
begin
                      if not first then
                        begin
                         first:=true;
                         if not AnalyseCommand(buffer) then
                                   begin error(1);exit;end;


                         case actualText of
                            Command_: begin
                                       actualText:=Param_; {toggle}
                                       waitForParam:=true;
                                       waitForCommand:=false;
                                       endCommandIndex:=mainIndex;
                                       compiledCodeCount:=CompiledCodeCount+1;
                                       if commandcode='D' then
                                         begin
                                          Repeat_level_counter:=
                                            Repeat_level_counter+1;
                                          commandcode:=commandcode+
                                             intTostr(Repeat_level_counter);
                                         end;
                                       if commandcode=']' then
                                           begin
                                           commandcode:=commandcode+
                                             intTostr(Repeat_level_counter);
                                            Repeat_level_counter:=
                                            Repeat_level_counter-1;

                                           end;
                                       compiledCode[compiledcodecount][0]:=
                                                 commandcode;

                                       buff:=commandcode+' ';

                                       if commandcode[1]=']' then
                                         begin

                                           actualText:=Command_; {toggle}
                                           waitForParam:=false;
                                           waitForCommand:=True;
                                           endCommandIndex:=mainIndex;
                                       compiledCode[compiledcodecount][1]:='0';
                                           buff:=buff+'0';

                                           listbox1.items.add(buff);
                                         end;
                                      end;
                            Param_: begin
                                      actualText:=Command_; {toggle}
                                      waitForParam:=false;
                                      waitForCommand:=True;
                                      endCommandIndex:=mainIndex;
                               compiledCode[compiledcodecount][1]:=commandcode;
                                      buff:=buff+commandcode;

                                      listbox1.items.add(buff);

                                    end;
                           end; {case}
                         buffer:=''; {clear buffer}
                        end;
                    end;

procedure TFormLogi.error(error_code:integer);
var mess:string;
begin
if not alreadyError then
begin
 
 memo1.selstart:=startselectionIndex-1;
 memo1.sellength:=mainIndex-startselectionIndex;
 alreadyError:=true;        {this needed to avoid two error_messages}
 case error_code of
 0:mess:='No Code';
 1:mess:='Code error';
 7:mess:='Check [ ] brakets';
 8:mess:='Programm must end with a sole *';
 10:mess:='Unknown command';
 11:mess:='Wrong number';
 12:mess:='Too many lines!';
 13:mess:='Problem with brakets!';
 15:mess:='Number out of range!';
 30:mess:='Unknown parameter';
 32:begin mess:='Number of REPEATs must be positive!';
           memo1.selstart:=0; memo1.sellength:=length(memo1.text);end;
 end;
 messageDlg('Error : '+mess,mtError,[mbOK],0);

end;
end;

function TFormLogi.AnalyseCommand(buffer:string):boolean;
var idx,foundindex:integer;
number:Longint;
    s1,s2:array[0..79]of char;
    s0:string;
begin
  foundindex:=-1;
 commandcode:='';
 number:=-100000;
 try
 number:=strtoint(buffer);
 if (number>32767)or(number<-32768) then begin error(15);exit;end;
 commandcode:=buffer;
 except on EConvertError do
  begin
    number:=0;
    foundindex:=0;
    idx:=0;
    StrPCopy(s1,buffer);
   repeat
     idx:=idx+1;
     s0:=LOGI_Instruction[idx];
     strPCopy(s2,s0);
     if (StrLIComp(s1,s2,length(s0))=0)and (length(s0)=length(buffer)) then
         foundindex:=idx;
        {case insensitive comparison}
  until (idx>=n)or(foundindex>=1);   //don't forget here is n
   if foundIndex>=1 then commandCode:=LOGI_Instruction[foundIndex];
  end;
 end;  {try}
 case ActualText of
  command_: begin
             if foundindex>7 then begin error(10);exit;end;
             if number<-40000 then begin error(11);exit;end;
             
            end;
  param_:   begin
             if (foundindex<=7)and(foundindex>=1) then begin error(30);exit;end;
            end;
  end; {case}
 if commandcode='MISSION' then commandcode:='P';
 if commandcode='DIRECTION' then commandcode:='K';
 if commandcode='ALPHA' then commandcode:='0';
 if commandcode='BETA' then commandcode:='1';
 if commandcode='GAMMA' then commandcode:='2';
 if commandcode='DELTA' then commandcode:='3';
 if commandcode='EPSILON' then commandcode:='4';
 if commandcode='REPEAT' then commandcode:='D';
 if commandcode='FORWARD' then commandcode:='F';
 if commandcode='RIGHT' then commandcode:='R';
 if commandcode='LEFT' then commandcode:='L';
 if commandcode='N' then commandcode:='0';
 if commandcode='E' then commandcode:='90';
 if commandcode='S' then commandcode:='180';
 if commandcode='W' then commandcode:='270';
 if commandcode='NW' then commandcode:='315';
 if commandcode='NE' then commandcode:='45';
 if commandcode='SW' then commandcode:='225';
 if commandcode='SE' then commandcode:='135';
 if commandcode='NNW' then commandcode:='338';
 if commandcode='NWW' then commandcode:='293';
 if commandcode='SSW' then commandcode:='203';
 if commandcode='SWW' then commandcode:='248';
 if commandcode='NNE' then commandcode:='23';
 if commandcode='NEE' then commandcode:='68';
 if commandcode='SSE' then commandcode:='158';
 if commandcode='SEE' then commandcode:='113';
 if commandcode<>'' then result:=true else result:=false;

end;



procedure TFormLogi.Spirit1DownloadDone(Sender: TObject; ErrorCode,
  DownloadNo: Smallint);
begin

 if errorcode=0 then spirit1.playSystemsound(3) else
   messagedlg('An error occured while transmitting task '+inttostr(DownLoadNo),
      mterror,[mbOK],0);

end;

function TFormLogi.testports:boolean;
var Comidx,ComPort: smallInt;
    testPort,ready:boolean;   {testport only true if Tower well connected and working}
begin

testPort:=false;

for Comidx:=1 to 4 do             {test all ports}
if not testport then
 begin
  application.processmessages;
  ready:=true;
  spirit1.ComPortNo:=ComIdx;
  If spirit1.initComm then        {first test the communication}
    begin
      if spirit1.TowerAndCableConnected then    {test the connection}
         begin
           Comport:=Comidx;
           testPort:=true;
         end else Ready:=false;
    end else  Ready:=false;
 end;

       if ready then
             if spirit1.TowerAlive then         {test the tower}
                 
                  If not spirit1.PBAliveOrNot then   {test the RCX}
                                         ready:=false;

  result:=ready;

end;

procedure TFormLogi.Memo1Change(Sender: TObject);
begin
 dirty:=true;
end;

procedure TFormLogi.New1Click(Sender: TObject);
begin
if dirty then
 if messagedlg('Do you want to save?', mtConfirmation,[mbYes,mBno],0)=mrYes
   then save1click(sender);
 memo1.clear;
 listbox1.clear;
 dirty:=false;
 FormPaint(Sender);
 FormLogi.caption:='LOGI';
 memo1.setfocus;
 savedialog1.filename:='';
end;

procedure TFormLogi.Open1Click(Sender: TObject);
begin
if dirty then
 if messagedlg('Do you want to save?', mtConfirmation,[mbYes,mBno],0)=mrYes
   then save1click(sender);

if opendialog1.execute then
begin
  formPaint(sender);
 FormLogi.caption:='LOGI '+opendialog1.filename;
 listbox1.clear;
 memo1.lines.loadfromfile(opendialog1.filename);
 savedialog1.filename:=opendialog1.filename;
 dirty:=false;
 memo1.setfocus;
end;
end;

procedure TFormLogi.SaveAs1Click(Sender: TObject);
begin
if savedialog1.execute then
  begin
    formLogi.caption:='LOGI '+savedialog1.filename;
    memo1.lines.savetofile(savedialog1.filename);
    dirty:=false;
    memo1.setfocus;
  end;
end;

procedure TFormLogi.Save1Click(Sender: TObject);
begin
if savedialog1.filename='' then saveas1click(sender) else
  begin
    memo1.lines.savetofile(savedialog1.filename);
    dirty:=false;
    memo1.setfocus;
  end;
end;

procedure TFormLogi.FormCreate(Sender: TObject);
begin
 dirty:=false;
 image1.picture.bitmap.width:=400;
 image1.picture.bitmap.height:=600;
 grid_width:=1; {dm}
 alpha:=0;
 Zoom:=10;
end;


procedure TFormLogi.Parameters1Click(Sender: TObject);
begin
if testports then
  begin
   FormResetRoby1.edit5.text:=inttostr(spirit1.poll(0,time_per_dm));
   FormResetRoby1.edit6.text:=inttostr(spirit1.poll(0,time_per_90));
   FormResetRoby1.edit7.text:=inttostr(spirit1.poll(0,rotations_per_dm));
   FormResetRoby1.edit8.text:=inttostr(spirit1.poll(0,rotations_per_90));

  end else
  begin
    messagedlg('Communicationproblem',mterror,[mbOK],0);
    FormResetRoby1.edit5.text:='?';
    FormResetRoby1.edit6.text:='?';
    FormResetRoby1.edit7.text:='?';
    FormResetRoby1.edit8.text:='?';

  end;
 if FormResetRoby1.showmodal=mrOK then
 begin
      
     if testports then
       with spirit1 do
       begin
         setvar(time_per_dm,con,strToint(FormResetRoby1.edit1.text));
         setvar(time_per_90,con,strToint(FormResetRoby1.edit2.text));
         setvar(rotations_per_dm,con,strtoint(FormResetRoby1.edit3.text));
         setvar(rotations_per_90,con,strtoint(FormResetRoby1.edit4.text));
       end else
        begin
         messagedlg('Communicationproblem',mterror,[mbOK],0);
         FormResetRoby1.edit1.text:=FormResetRoby1.t1;
         FormResetRoby1.edit2.text:=FormResetRoby1.t2;
         FormResetRoby1.edit3.text:=FormResetRoby1.t3;
         FormResetRoby1.edit4.text:=FormResetRoby1.t3;

        end;
 end;
end;

procedure TFormLogi.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 if dirty then
 if messagedlg('Do you want to save?', mtConfirmation,[mbYes,mBno],0)=mrYes
   then save1click(sender);
end;

procedure TFormLogi.Help1Click(Sender: TObject);
begin
  FormHelp.show;
end;

procedure TFormLogi.FormPaint(Sender: TObject);
begin
 memo1.left:=2;                         {adjusts the window-controls}
 memo1.width:=(formLogi.width Div 2)-4;
 memo1.height:=formLogi.height-150;
 panel1.left:=memo1.width+4;
 panel1.width:=memo1.width-4;
 panel1.height:=memo1.height;
 button1.left:=(formLogi.width div 4)-(button1.width div 2);
 button1.top:=(memo1.height+30);
 button2.left:=((3 * formLogi.width) div 4)-(button1.width div 2);
 button2.top:=button1.top;
 spirit1.top:=button2.top+10;
 spirit1.left:=(formLogi.width div 2)-18;
 grid_step:=image1.width div ZOOM;
 start_x:=5*grid_step;
 start_y:=(image1.height div grid_step)div 2*grid_step;
 clear_image;
 draw_turtle;

end;

procedure TFormLogi.FormResize(Sender: TObject);
begin
 formpaint(sender);
end;

procedure TFormLogi.Clear_Image;
var idx:integer;
begin

 grid_step:=image1.width div ZOOM;
 with image1.picture.bitmap.canvas do
 begin
   pen.width:=1;
   pen.color:=clblack;
   rectangle(0,0,400,600);  {clears the test-pad}

   pen.color:=clsilver;
   for idx:=1 to ZOOM do
     begin
       moveto(idx*grid_step,0);
       lineto(idx*grid_step,image1.height);
     end;
   for idx:=1 to image1.height div grid_step do
      begin
       moveto(0,idx*grid_step);
       lineto(image1.width,idx*grid_step);
      end;
   pen.color:=clnavy;
   case grid_width of
   1:   textout(23,25,'dm');
   10:   textout(23,25,'m');
   100:  textout(23,25,'dam');
   end;
   if zoom<=10 then pen.width:=3 else
        if zoom<=20 then pen.width:=2 else pen.width:=1;


  end; {with}
 alpha:=0; {reset the angle}
 image1.picture.bitmap.canvas.moveto(start_x,start_y);
posx:=start_x;posy:=start_y;
end;

procedure TFormLogi.Testgitter1Click(Sender: TObject);
begin
 if FormGrid.showmodal=mrOK then
   begin
    case FormGrid.radiogroup1.itemindex of
     0:grid_width:=1;  {dm}
     1:grid_width:=10;
     2:grid_width:=100;
     end;
      clear_image;
      draw_turtle;
   end;

end;

function TFormLogi.testpadpos(argument:real):integer;    {converts values to pixels}
begin
  {1 grid_step = grid_width}
  result:=round(argument*grid_step/grid_width);
end;

procedure TFormLogi.draw_turtle;
var delta:integer;
    myrect:Trect;
begin
delta:=testpadpos(0.5);
if delta<2 then delta:=2;
myrect:=rect(start_x-delta,start_y,start_x+delta,start_y+2*delta);
image1.picture.bitmap.canvas.stretchdraw(myrect,image2.picture.bitmap);
image1.picture.bitmap.canvas.moveto(start_x,start_y);
posx:=start_x;posy:=start_y;
end;

procedure TFormLogi.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 start_x:=x;
 start_y:=y;
 clear_image;
 draw_turtle;
end;
procedure TFormLogi.Draw_Lines;
var start,finish:integer;
begin
clear_image;
start:=1;finish:=compiledcodeCount;
 if compiledCodeCount>0 then execute_code(start,finish);
end;

procedure TFormLogi.Execute_code(start,finish:integer);
var argument:real;
    idx0,idx1,idx2,Repeat_level,skip_index:integer;
    skip,found:boolean;
    function extract_level_counter(i:integer):integer;
    var idx:integer;
        s:string[10];
    begin
    s:='';
     for idx:=2 to length(compiledCode[i][0]) do s:=s+compiledCode[i][0][idx];
     result:=strToint(s);

    end;
begin
if not alreadyerror then
begin
  skip:=false;found:=false;
     for idx0:=start to finish do
     begin
     if not skip then
      begin
       if compiledCode[idx0][0]='F' then
               begin
                argument:=strToint(compiledCode[idx0][1])/10;
                posx:=posx+sin(alpha*pi/180)*testpadpos(argument);
                posy:=posy-cos(alpha*pi/180)*testpadpos(argument);
                image1.picture.bitmap.canvas.lineto(round(posx),round(posy));
               end;
       if compiledCode[idx0][0]='L' then
               begin alpha:=alpha-strToint(compiledCode[idx0][1]); end;
       if compiledCode[idx0][0]='R' then
               begin alpha:=alpha+strToint(compiledCode[idx0][1]); end;
       if compiledCode[idx0][0]='K' then
               begin alpha:=strToint(compiledCode[idx0][1]); end;
       if compiledCode[idx0][0]='P' then
               begin
                with image1.picture.bitmap.canvas do
                  begin
                    case strToint(compiledCode[idx0][1]) of
                      0: brush.color:=cllime;
                      1: brush.color:=clfuchsia;
                      2: brush.color:=claqua;
                      3: brush.color:=clyellow;
                      4: brush.color:=clsilver;
                    end;
                  ellipse(round(posx-2*pen.width),round(posy-2*pen.width),
                     round(posx+2*pen.width),round(posy+2*pen.width));
                  brush.color:=clwhite;
                  moveto(round(posx),round(posy));

                  end;
               end;
       if compiledCode[idx0][0][1]='D' then
          begin
            repeat_level:=extract_level_counter(idx0);
            skip:=true;
            idx1:=idx0-1;
            repeat
              idx1:=idx1+1;
              if  compiledCode[idx1][0][1]=']' then
                if repeat_level=extract_level_counter(idx1) then found:=true;
            until found;   {find out position of ] }
             skip_index:=idx1;
             if strToint(compiledCode[idx0][1])<0 then begin error(32);exit;end;
             if  strToint(compiledCode[idx0][1])=0 then
               for idx2:=1 to 500 do  execute_code(idx0+1,idx1-1) else
            for idx2:=1 to  strToint(compiledCode[idx0][1]) do
                execute_code(idx0+1,idx1-1);

          end;
       end else    {if skip}
         begin
          if skip_index=idx0  then begin skip:=false;found:=false;end;
         end;
     end; {for idx0}
end;
end;



procedure TFormLogi.ZoomoutClick(Sender: TObject);
begin
if zoom<30 then Zoom:=Zoom+5;
 clear_image;
 draw_turtle;
end;

procedure TFormLogi.Zoomin1Click(Sender: TObject);
begin
if zoom>5 then zoom:=zoom-5;
clear_image;
draw_turtle;
end;

procedure TFormLogi.Slot1Click(Sender: TObject);
begin
  formslot.showmodal;
end;

{=============================================================================}


procedure TFormLogi.Send1Click(Sender: TObject);
begin
 if testports then
   begin
     with spirit1 do
       begin
{==========================================}
setvar(time_per_dm,con,50);  // initialization
setvar(time_per_90,con,90);
setvar(direction,con,0); //equivalent to alpha, has to be reset
selectprgm(formslot.radiogroup1.itemindex);

beginoftask(main);

   {Turtle_reset}
  setpower(drive_motors,con,3);
  starttask(procedure_);

endoftask();

{========================================}

beginofsub(forward_);
  mulvar(argument,var_iable,time_per_dm);
  divvar(argument,con,10);   {now argument holds the action-time, + or - signed}
  if_(var_iable,argument,LT,con,0);
    setfwd(left_motor);
    setrwd(right_motor);
    absvar(argument,var_iable,argument);
  else_();
    setrwd(left_motor);
    setfwd(right_motor);
  endif();
  on_(drive_motors);
  wait(var_iable,argument);
  off(drive_motors);
endofsub();

beginofsub(left_);
  while_(var_iable,argument,GT,con,180);   //argument must be <=180
    subvar(argument,con,360);
  endwhile();
  while_(var_iable,argument,LT,con,-180);    //argument must be >=-180
    sumvar(argument,con,360);
  endwhile();
  subvar(direction,var_iable,argument);
  while_(var_iable,direction,GT,con,360);   //direction must be <=360
   subvar(direction,con,360);
  endwhile();
  while_(var_iable,direction,LT,con,0);     //direction must be >=0
   sumvar(direction,con,360);
  endwhile();
  mulvar(argument,var_iable,time_per_90);
  divvar(argument,con,90);   {now argument holds the action-time, + or - signed}
  if_(var_iable,argument,LT,con,0);
    setrwd(drive_motors);
    absvar(argument,var_iable,argument);
  else_();
    setfwd(drive_motors);
  endif();
  on_(drive_motors);
  wait(var_iable,argument);
  off(drive_motors);
endofsub();

beginofsub(right_);
while_(var_iable,argument,GT,con,180);   //argument must be <=180
  subvar(argument,con,360);
endwhile();
while_(var_iable,argument,LT,con,-180);    //argument must be >=-180
  sumvar(argument,con,360);
endwhile();
sumvar(direction,var_iable,argument);
  while_(var_iable,direction,GT,con,360);   //direction must be <=360
subvar(direction,con,360);
  endwhile();
while_(var_iable,direction,LT,con,0);     //direction must be >=0
sumvar(direction,con,360);
endwhile();
  mulvar(argument,var_iable,time_per_90);
  divvar(argument,con,90);   {now argument holds the action-time, + or - signed}
  if_(var_iable,argument,LT,con,0);
    setfwd(drive_motors);
    absvar(argument,var_iable,argument);
  else_();
    setrwd(drive_motors);
  endif();
  on_(drive_motors);
  wait(var_iable,argument);
  off(drive_motors);
endofsub();

beginofsub(Cap_);
 while_(var_iable,argument,GT,con,360);   //argument must be <=360
  subvar(argument,con,360);
 endwhile();
 while_(var_iable,argument,LT,con,0);     //argument must be >=0
  sumvar(argument,con,360);
 endwhile();
  setvar(calc,var_iable,argument);
  subvar(calc,var_iable,direction);      {compare to old direction}
  setvar(direction,var_iable,argument);   {set new direction}
  if_(var_iable,calc,GT,con,180);
    subvar(calc,con,360);
  endif();
  if_(var_iable,calc,LT,con,-180);
    sumvar(calc,con,360);
  endif();
  mulvar(calc,var_iable,time_per_90);
  divvar(calc,con,90);   {now calc holds the action-time, + or - signed}
  if_(var_iable,calc,LT,con,0);
    setfwd(drive_motors);
    absvar(calc,var_iable,calc);
  else_();
    setrwd(drive_motors);
  endif();
  on_(drive_motors);
  wait(var_iable,calc);
  off(drive_motors);

endofsub();
{==========================================}
{==========================================}

beginoftask(procedure_);
  {draw a square to the left}
  loop(con,4);
    setvar(argument,con,40);
    gosub(forward_);
    setvar(argument,con,90);
    gosub(left_);
  endloop();
  {draw a square to the right}
  loop(con,4);
    setvar(argument,con,40);
    gosub(forward_);
    setvar(argument,con,90);
    gosub(right_);
  endloop();
 endoftask();

       end;
   end else messagedlg('Communicationproblem',mterror,[mbOK],0);
end;

{============================================================================}
procedure TFormLogi.Hauptprogramm2Click(Sender: TObject);
begin
 if testports then
   begin
     with spirit1 do
       begin
{==========================================}
setvar(rotations_per_dm,con,32);
setvar(rotations_per_90,con,25);
setvar(direction,con,0); //equivalent to alpha, has to be reset
selectprgm(formslot.radiogroup1.itemindex);

beginoftask(main);

   {Turtle_reset}
  setsensortype(0,4); {rotation-sensor}
  setpower(drive_motors,con,3);
  starttask(procedure_);

endoftask();

{========================================}

beginofsub(forward_);
  mulvar(argument,var_iable,rotations_per_dm);
  divvar(argument,con,10);   {now argument holds the action-time, + or - signed}
  if_(var_iable,argument,LT,con,0);
    setfwd(left_motor);
    setrwd(right_motor);
    absvar(argument,var_iable,argument);
  else_();
    setrwd(left_motor);
    setfwd(right_motor);
  endif();
  clearsensorvalue(0);
  setvar(rotations,con,0);
  on_(drive_motors);
   while_(var_iable,rotations,LT,var_iable,argument);
   setvar(rotations,senval,0);
   absvar(rotations,var_iable,rotations);
   endwhile();
  off(drive_motors);
endofsub();

beginofsub(left_);
  while_(var_iable,argument,GT,con,180);   //argument must be <=180
    subvar(argument,con,360);
  endwhile();
  while_(var_iable,argument,LT,con,-180);    //argument must be >=-180
    sumvar(argument,con,360);
  endwhile();
  subvar(direction,var_iable,argument);      //substract to direction
  while_(var_iable,direction,GT,con,360);   //direction must be <=360
   subvar(direction,con,360);
  endwhile();
  while_(var_iable,direction,LT,con,0);     //direction must be >=0
   sumvar(direction,con,360);
  endwhile();
  mulvar(argument,var_iable,rotations_per_90);
  divvar(argument,con,90);   {now argument holds the action-time, + or - signed}
  if_(var_iable,argument,LT,con,0);
    setrwd(drive_motors);
    absvar(argument,var_iable,argument);
  else_();
    setfwd(drive_motors);
  endif();
  clearsensorvalue(0);
  setvar(rotations,con,0);
  on_(drive_motors);
   while_(var_iable,rotations,LT,var_iable,argument);
   setvar(rotations,senval,0);
   absvar(rotations,var_iable,rotations);
   endwhile();
  off(drive_motors);
endofsub();

beginofsub(right_);
  while_(var_iable,argument,GT,con,180);   //argument must be <=180
    subvar(argument,con,360);
  endwhile();
  while_(var_iable,argument,LT,con,-180);    //argument must be >=-180
    sumvar(argument,con,360);
  endwhile();
  sumvar(direction,var_iable,argument);    //add to direction
  while_(var_iable,direction,GT,con,360);   //direction must be <=360
   subvar(direction,con,360);
  endwhile();
  while_(var_iable,direction,LT,con,0);     //direction must be >=0
   sumvar(direction,con,360);
  endwhile();
  mulvar(argument,var_iable,rotations_per_90);
  divvar(argument,con,90);   {now argument holds the action-time, + or - signed}
  if_(var_iable,argument,LT,con,0);
    setfwd(drive_motors);
    absvar(argument,var_iable,argument);
  else_();
    setrwd(drive_motors);
  endif();
  clearsensorvalue(0);
  setvar(rotations,con,0);
  on_(drive_motors);
  while_(var_iable,rotations,LT,var_iable,argument);
   setvar(rotations,senval,0);
   absvar(rotations,var_iable,rotations);
  endwhile() ;
  off(drive_motors);
endofsub();

beginofsub(Cap_);
 while_(var_iable,argument,GT,con,360);   //argument must be <=360
  subvar(argument,con,360);
 endwhile();
 while_(var_iable,argument,LT,con,0);     //argument must be >=0
  sumvar(argument,con,360);
 endwhile();
  setvar(calc,var_iable,argument);
  subvar(calc,var_iable,direction);
  setvar(direction,var_iable,argument);
  if_(var_iable,calc,GT,con,180);   {search the nearest turn < 180}
    subvar(calc,con,360);
  endif();
  if_(var_iable,calc,LT,con,-180);
    sumvar(calc,con,360);
  endif();
  if_(var_iable,calc,LT,con,0);
    setfwd(drive_motors);
    absvar(argument,var_iable,argument);
  else_();
    setrwd(drive_motors);
  endif();
  mulvar(calc,var_iable,rotations_per_90);
  divvar(calc,con,90);
  absvar(calc,var_iable,calc);
  clearsensorvalue(0);
  setvar(rotations,con,0);
  on_(drive_motors);
  while_(var_iable,rotations,LT,var_iable,calc);
   setvar(rotations,senval,0);
   absvar(rotations,var_iable,rotations);
  endwhile() ;
  off(drive_motors);
endofsub();
{==========================================}
{==========================================}

beginoftask(procedure_);
  {draw a square to the left}
  loop(con,4);
    setvar(argument,con,40);
    gosub(forward_);
    setvar(argument,con,90);
    gosub(left_);
  endloop();
  {draw a square to the right}
  loop(con,4);
    setvar(argument,con,40);
    gosub(forward_);
    setvar(argument,con,90);
    gosub(right_);
  endloop();

endoftask();

       end;
   end else messagedlg('Communicationproblem',mterror,[mbOK],0);
end;



end.
